Public Class GreekBibleBook

    Const MaxChapters As Integer = 28
    Const MaxVerses As Integer = 89

    Dim FullPath As String
    Dim Path As String

    Dim Title As String

    Dim Reference(MaxChapters, MaxVerses) As String 'Chapter, verse, string contains position of that reference found in text and its length i.e 0x100

    Enum BibleBookFormat
        TRPRSD
        WHN27PRS
        SCRTR
    End Enum

    Dim Formatting As BibleBookFormat

    Dim LastPos As Long

    Public Function GetReference(ByVal Chapter As Integer, ByVal Verse As Integer)
        Dim splitchar() As Char = {CChar("x")}
        Dim refs() As String = Reference(Chapter, Verse).Split(splitchar)

        Dim startline As Long = CLng(refs(0))
        Dim endline As Long = CLng(refs(1))

        Dim sr As New IO.StreamReader(FullPath)
        sr.BaseStream.Seek(0, IO.SeekOrigin.Begin)
        Dim sOut As String = ""
        Dim TextRead As String
        Dim cLine As Integer
        Do
            TextRead = sr.ReadLine
            If cLine >= startline And cLine <= endline Then
                sOut &= TextRead
            End If
            cLine += 1
        Loop Until cLine > endline
        Return sOut
    End Function

    Public Sub New(ByVal filename As String, ByVal f As BibleBookFormat)
        On Error Resume Next
        FullPath = filename
        Formatting = f

        Dim sr As New IO.StreamReader(FullPath)
        sr.BaseStream.Seek(0, IO.SeekOrigin.Begin)
        Dim TextRead As String
        Dim VerseText As String
        Dim FirstTry As Boolean = True
        Dim StartLine, CurrLine As Integer
        CurrLine = 0
        StartLine = 0
        LastPos = 0
        Do Until sr.Peek <= -1
            TextRead = sr.ReadLine
            If IsVerse(TextRead) Then
                If FirstTry Then
                    FirstTry = False
                    StartLine = CurrLine
                    VerseText = TextRead
                Else
                    AddReference(VerseText, StartLine & "x" & CurrLine)
                    StartLine = CurrLine
                    LastPos += VerseText.Length + 1
                    VerseText = TextRead
                End If
            Else
                If Formatting = BibleBookFormat.WHN27PRS Then
                    VerseText &= " " & TextRead
                Else
                    If Formatting = BibleBookFormat.SCRTR Then
                        TextRead = TextRead.Replace("     ", "")
                    End If
                    VerseText &= " " & TextRead
                End If
            End If
            CurrLine += 1
        Loop
        AddReference(VerseText, StartLine & "x" & CurrLine - 1) 'add the last verse

        sr.Close()
        sr = Nothing
    End Sub

    Private Sub AddReference(ByVal str As String, ByVal str2 As String)
        If Formatting = BibleBookFormat.TRPRSD Then
            If Char.IsNumber(str.Chars(0)) Then
                Dim beforeColon As Boolean = True
                Dim c As Integer
                Dim chap As String = ""
                Dim vrs As String = ""
                For c = 0 To str.Length - 1
                    If Char.IsNumber(str.Chars(c)) Then
                        If beforeColon Then
                            chap &= str.Chars(c)
                        Else
                            vrs &= str.Chars(c)
                        End If
                    Else
                        If str.Chars(c) = CChar(":") Then
                            beforeColon = False
                        ElseIf str.Chars(c) = CChar(" ") Then
                            If beforeColon = False Then Exit For
                        End If
                    End If
                Next

                Reference(chap, vrs) = str2 'LastPos & "x" & str.Length


            End If
        ElseIf Formatting = BibleBookFormat.WHN27PRS Then
            If str.StartsWith("     ") Then
                Dim beforeColon As Boolean = True
                Dim c As Integer
                Dim chap As String = ""
                Dim vrs As String = ""
                For c = 0 To str.Length - 1
                    If Char.IsNumber(str.Chars(c)) Then
                        If beforeColon Then
                            chap &= str.Chars(c)
                        Else
                            vrs &= str.Chars(c)
                        End If
                    Else
                        If str.Chars(c) = CChar(":") Then
                            beforeColon = False
                        ElseIf str.Chars(c) = CChar(" ") Then
                            If beforeColon = False Then Exit For
                        End If
                    End If
                Next

                Reference(chap, vrs) = str2 'LastPos & "x" & str.Length

            End If
        ElseIf Formatting = BibleBookFormat.SCRTR Then
            If str.StartsWith("          ") And Char.IsNumber(str.Chars(10)) Then
                Dim beforeColon As Boolean = True
                Dim c As Integer
                Dim chap As String = ""
                Dim vrs As String = ""
                For c = 0 To str.Length - 1
                    If Char.IsNumber(str.Chars(c)) Then
                        If beforeColon Then
                            chap &= str.Chars(c)
                        Else
                            vrs &= str.Chars(c)
                        End If
                    Else
                        If str.Chars(c) = CChar(":") Then
                            beforeColon = False
                        ElseIf str.Chars(c) = CChar(" ") Then
                            If beforeColon = False Then Exit For
                        End If
                    End If
                Next

                Reference(chap, vrs) = str2 'LastPos & "x" & str.Length

            End If
        End If
    End Sub

    Private Function IsVerse(ByVal str As String) As Boolean
        If Formatting = BibleBookFormat.TRPRSD Then
            If Char.IsNumber(str.Chars(0)) Then
                Return True
            Else
                Return False
            End If
        ElseIf Formatting = BibleBookFormat.WHN27PRS Then
            If str.StartsWith("     ") Then
                Return True
            Else
                Return False
            End If
        ElseIf Formatting = BibleBookFormat.SCRTR Then
            If str.StartsWith("          ") Then
                If Char.IsNumber(str.Chars(10)) Then
                    Return True
                Else
                    Return False
                End If
            Else
                Return False
            End If
        Else
            Return False
        End If

    End Function

End Class
