Module Main
#Region "Bible Books"

    Public BooksOfBible() As String = {"Matthew", _
"Mark", _
"Luke", _
"John", _
"Acts", _
"Romans", _
"1 Corinthians", _
"2 Corinthians", _
"Galatians", _
"Ephesians", _
"Philippians", _
"Colossians", _
"1 Thessalonians", _
"2 Thessalonians", _
"1 Timothy", _
"2 Timothy", _
"Titus", _
"Philemon", _
"Hebrews", _
"James", _
"1 Peter", _
"2 Peter", _
"1 John", _
"2 John", _
"3 John", _
"Jude", _
"Revelation"}
#End Region

    Public ReferenceLib As ReferenceLibrary
    Public CBook, CChapter, CVerse As Integer
    Public GreekNumbers, Parsing As Boolean
    Public VerseIndex As Integer

    Function main() As Integer
        Dim fmid As New frmMDI

        Dim splash As New frmSplash
        splash.Show()
        Application.DoEvents()

        fmid.InitLibrary()
        ReferenceLib = New ReferenceLibrary(splash, fmid.DataLib)

        Languages.LoadLangList(Application.StartupPath & "\Data\Languages.txt")

        Dim i As Integer

        fmid.BibleBrowser1.RefObj.NumberOfRefs = 1
        fmid.BibleBrowser1.RefObj.Refs(0) = 0
        fmid.BibleBrowser1.RefObj.Refs(1) = 1
        fmid.BibleBrowser1.RefObj.RefLang(0) = ReferenceObj.BrowserLanguageStyle.Greek
        fmid.BibleBrowser1.RefObj.RefLang(1) = ReferenceObj.BrowserLanguageStyle.Greek
        'fmid.BibleBrowser1.cmboSet.SelectedIndex = 0

        fmid.BibleBrowser2.RefObj.NumberOfRefs = 1
        fmid.BibleBrowser2.RefObj.Refs(0) = 0
        fmid.BibleBrowser2.RefObj.Refs(1) = 1
        fmid.BibleBrowser2.RefObj.RefLang(0) = ReferenceObj.BrowserLanguageStyle.English
        fmid.BibleBrowser2.RefObj.RefLang(1) = ReferenceObj.BrowserLanguageStyle.English
        'fmid.BibleBrowser2.cmboSet.SelectedIndex = 0

        For i = 0 To ReferenceLib.ScriptureVerses.Length - 1
            fmid.BibleBrowser1.lstVerse.Items.Add(ReferenceLib.ScriptureVerses(i))
            fmid.BibleBrowser2.lstVerse.Items.Add(ReferenceLib.ScriptureVerses(i))
        Next


        UpdateRef(0, 1, 1, fmid, 0, 0)

        Dim LastChapter As Integer
        Dim splitchar() As Char = {CChar(":")}
        Dim vrss() As String

        For Each book As String In BooksOfBible
            Dim nd As New TreeNode(book, 0, 1)
            LastChapter = 0
            For Each vrs As String In ReferenceLib.ScriptureVerses
                If InStr(vrs, book, CompareMethod.Text) <> 0 Then
                    vrs = vrs.Replace(book, "")
                    vrs = vrs.Replace(" ", "")
                    vrss = vrs.Split(splitchar)
                    If Not CInt(vrss(0)) = LastChapter Then
                        LastChapter = CInt(vrss(0))
                        nd.Nodes.Add(LastChapter)
                    End If
                End If
            Next
            fmid.treeBible.Nodes.Add(nd)
            nd = Nothing
        Next

        fmid.cmboSet.SelectedIndex = 0

        splash.Hide()
        splash = Nothing

        fmid.ShowDialog()

        Return 0
    End Function

    Public Sub UpdateRef(ByVal book As Integer, ByVal chap As Integer, ByVal vrs As Integer, ByVal f As frmMDI, ByVal i As Integer, ByVal SetNumber As Integer)
        On Error Resume Next
        GreekNumbers = False
        Parsing = False
        CBook = book
        CChapter = chap
        CVerse = vrs
        VerseIndex = i
        f.BibleBrowser1.DoUpdate = True
        f.BibleBrowser2.DoUpdate = True
    End Sub

    Public Sub UpdateNotes(ByVal rtfNotes As RichTextBox, ByVal f As frmMDI)
        On Error Resume Next
        f.BibleBrowser1.rtfNotes.Rtf = rtfNotes.Rtf
        f.BibleBrowser2.rtfNotes.Rtf = rtfNotes.Rtf
        Dim rtf As New RichTextBox
        rtf.Rtf = rtfNotes.Rtf
        rtf.SaveFile(Application.StartupPath & "\Notes\" & CBook & "x" & CChapter & "x" & CVerse & ".rtf")
    End Sub

    Public Sub GoToReference(ByVal verseText As String, ByVal frm As frmMDI, ByVal SetNumber As Integer)
        On Error Resume Next

        Dim bookname As String
        Dim splitchar1() As Char = {CChar(" ")}
        Dim ary1() As String
        If Char.IsNumber(verseText.Chars(0)) Then
            ary1 = verseText.Split(splitchar1)
            bookname = ary1(0) & " " & ary1(1)
        Else
            ary1 = verseText.Split(splitchar1)
            bookname = ary1(0)
        End If

        Dim bk, chpt, vrs As Integer
        Dim i As Integer
        For i = 0 To BooksOfBible.Length - 1
            If InStr(BooksOfBible(i), bookname, CompareMethod.Text) <> 0 Then
                bk = i
                Exit For
            End If
        Next

        Dim ary2() As String
        Dim splitchar2() As Char = {CChar(":")}
        If Char.IsNumber(verseText.Chars(0)) Then
            ary2 = ary1(2).Split(splitchar2)
        Else
            ary2 = ary1(1).Split(splitchar2)
        End If

        chpt = CInt(ary2(0))
        vrs = CInt(ary2(1))

        If vrs <= 0 Then vrs = 1
        If chpt <= 0 Then chpt = 1

        UpdateRef(bk, chpt, vrs, frm, 0, SetNumber) 'Me.VerseScroll.Value)
    End Sub

End Module
